Description

Currently,

https://cdcvs.fnal.gov/redmine/projects/artdag/repository/revisions/develop/entry/artdag/DAQrate/SharedMemoryEventManager.cc#L
1202 will mark an event as incomplete and release it to art whenever the running flag is false, even if there are outstanding writes on
that buffer. This behavior can lead to issues when a Fragment is in the process of being written to the buffer and the state is changed
out from underneath it.

Probably a better way to do this would be to check the running_ flag at entry to the WriteFragmentHeader method, and remove the
check from L1202.

History

#1 - 03/16/2021 03:45 PM - Eric Flumerfelt

- Status changed from New to Resolved

Changes are on bugfix/25635_SMEM_EndOfDataRaceCondition. | have updated the unit tests to trigger the error, by calling WriteFragmentHeader,
then endOfData in a thread, and calling DoneWritingFragment after a short delay. The current artdaq code fails this test, throwing a signal 6 in the
process, while the fixed code passes. If you check out 60c08740, you will get the unit tests without the fixes.

#2 - 03/17/2021 04:37 PM - Gennadiy Lukhanin

Reviewed code; checked out 60c08740 and confirmed that the SharedMemoryEventManager_t test fails, merged the
bugfix/25635_SMEM_EndOfDataRaceCondition branch and confirmed that the SharedMemoryEventManager_t test succeeds.

#before the bug fix
Start 6: SharedMemoryEventManager_t
6/46 Test #6: SharedMemOryEVENtManager_ £ ..t ottt e et e eeeeeaeeaeeneennnn ***Failed 4.06 sec

#after the bug fix

Start 6: SharedMemoryEventManager_t
6/46 Test #6: SharedMemOryEVENtManager_ £ ..ttt in e teeeeeeeeeeeeeeeenenennens Passed 4.06 sec

#3 - 03/19/2021 10:19 AM - Gennadiy Lukhanin

- Status changed from Resolved to Reviewed
